﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AntiAircraftGun
{
    /// <summary>
    /// Расширение для класса DrawingAntiAircraftGun
    /// </summary>
    internal static class ExtentionAntiAircraftGun
    {
        /// <summary>
        /// Разделитель для записи информации по объекту в файл
        /// </summary>
        private static readonly char _separatorForObject = ':';
        /// <summary>
        /// Создание объекта из строки
        /// </summary>
        /// <param name="info"></param>
        /// <returns></returns>
        public static DrawingAntiAircraftGun CreateDrawingAntiAircraftGun(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawingAntiAircraftGun(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 6)
            {
                return new DrawingUpdateAntiAircraftGun(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                Convert.ToBoolean(strs[5]));
            }
            return null;
        }
        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawingAntiAircraftGun"></param>
        /// <returns></returns>
        public static string GetDataForSave(this DrawingAntiAircraftGun drawingAntiAircraftGun)
        {
            var antiAircraftGun = drawingAntiAircraftGun.AntiAircraftGun;
            var str = $"{antiAircraftGun.Speed}{_separatorForObject}{antiAircraftGun.Weight}{_separatorForObject}{antiAircraftGun.BodyColor.Name}";
            if (antiAircraftGun is not EntityUpdateAntiAircraftGun updateAntiAircraftGun)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{updateAntiAircraftGun.DopColor.Name}{_separatorForObject}{updateAntiAircraftGun.Gun}{_separatorForObject}{updateAntiAircraftGun.Radar}";
        }
    }
}
